<?php
spl_autoload_register(function($className) {
	$classes = [
		'Koala\AOP\After' => './Koala/AOP/After.php',
		'Koala\AOP\AfterReturning' => './Koala/AOP/AfterReturning.php',
		'Koala\AOP\AfterThrowing' => './Koala/AOP/AfterThrowing.php',
		'Koala\AOP\Around' => './Koala/AOP/Around.php',
		'Koala\AOP\Aspect' => './Koala/AOP/Aspect.php',
		'Koala\AOP\Before' => './Koala/AOP/Before.php',
		'Koala\AOP\Joinpoint' => './Koala/AOP/Joinpoint.php',
		'Koala\AOP\Abstraction\Advice' => './Koala/AOP/Abstraction/Advice.php',
		'Koala\AOP\Abstraction\Aspect' => './Koala/AOP/Abstraction/Aspect.php',
		'Koala\AOP\Abstraction\InterceptingMethod' => './Koala/AOP/Abstraction/InterceptingMethod.php',
		'Koala\AOP\Abstraction\Joinpoint' => './Koala/AOP/Abstraction/Joinpoint.php',
		'Koala\AOP\Abstraction\Pointcut' => './Koala/AOP/Abstraction/Pointcut.php',
		'Koala\AOP\Abstraction\Proxy' => './Koala/AOP/Abstraction/Proxy.php',
		'Koala\AOP\Abstraction\ProxyList' => './Koala/AOP/Abstraction/ProxyList.php',
		'Koala\AOP\Abstraction\Pointcut\AfterPointcut' => './Koala/AOP/Abstraction/Pointcut/AfterPointcut.php',
		'Koala\AOP\Abstraction\Pointcut\AfterReturningPointcut' => './Koala/AOP/Abstraction/Pointcut/AfterReturningPointcut.php',
		'Koala\AOP\Abstraction\Pointcut\AfterThrowingPointcut' => './Koala/AOP/Abstraction/Pointcut/AfterThrowingPointcut.php',
		'Koala\AOP\Abstraction\Pointcut\AroundPointcut' => './Koala/AOP/Abstraction/Pointcut/AroundPointcut.php',
		'Koala\AOP\Abstraction\Pointcut\BeforePointcut' => './Koala/AOP/Abstraction/Pointcut/BeforePointcut.php',
		'Koala\AOP\Advice\AdviceReflection' => './Koala/AOP/Advice/AdviceReflection.php',
		'Koala\AOP\Advice\SimpleAdviceReflection' => './Koala/AOP/Advice/SimpleAdviceReflection.php',
		'Koala\AOP\Aspect\AspectReflection' => './Koala/AOP/Aspect/AspectReflection.php',
		'Koala\AOP\Aspect\AspectServiceFilter' => './Koala/AOP/Aspect/AspectServiceFilter.php',
		'Koala\AOP\Aspect\PhpNativeAspectServiceFilter' => './Koala/AOP/Aspect/PhpNativeAspectServiceFilter.php',
		'Koala\AOP\Aspect\SimpleAspectReflection' => './Koala/AOP/Aspect/SimpleAspectReflection.php',
		'Koala\AOP\Interceptor\HashMapLoader' => './Koala/AOP/Interceptor/HashMapLoader.php',
		'Koala\AOP\Interceptor\Interceptor' => './Koala/AOP/Interceptor/Interceptor.php',
		'Koala\AOP\Interceptor\InterceptorTypes' => './Koala/AOP/Interceptor/InterceptorTypes.php',
		'Koala\AOP\Interceptor\Loader' => './Koala/AOP/Interceptor/Loader.php',
		'Koala\AOP\Interceptor\MethodInterceptorList' => './Koala/AOP/Interceptor/MethodInterceptorList.php',
		'Koala\AOP\Interceptor\MethodInvocation' => './Koala/AOP/Interceptor/MethodInvocation.php',
		'Koala\AOP\Pointcut\PointcutExpression' => './Koala/AOP/Pointcut/PointcutExpression.php',
		'Koala\AOP\Pointcut\PointcutExpressionResolver' => './Koala/AOP/Pointcut/PointcutExpressionResolver.php',
		'Koala\AOP\Pointcut\SimplePointcutExpressionResolver' => './Koala/AOP/Pointcut/SimplePointcutExpressionResolver.php',
		'Koala\AOP\Pointcut\Compiler\CompileMethodMatchVisitor' => './Koala/AOP/Pointcut/Compiler/CompileMethodMatchVisitor.php',
		'Koala\AOP\Pointcut\Compiler\MethodMatcherCompiler' => './Koala/AOP/Pointcut/Compiler/MethodMatcherCompiler.php',
		'Koala\AOP\Pointcut\Compiler\NotSupportedModifierException' => './Koala/AOP/Pointcut/Compiler/NotSupportedModifierException.php',
		'Koala\AOP\Pointcut\Compiler\PointcutToMatcherClassTranslation' => './Koala/AOP/Pointcut/Compiler/PointcutToMatcherClassTranslation.php',
		'Koala\AOP\Pointcut\Parser\AlreadyRecordingException' => './Koala/AOP/Pointcut/Parser/AlreadyRecordingException.php',
		'Koala\AOP\Pointcut\Parser\Lexer' => './Koala/AOP/Pointcut/Parser/Lexer.php',
		'Koala\AOP\Pointcut\Parser\NoRecordingStartedException' => './Koala/AOP/Pointcut/Parser/NoRecordingStartedException.php',
		'Koala\AOP\Pointcut\Parser\UnexpectedCharException' => './Koala/AOP/Pointcut/Parser/UnexpectedCharException.php',
		'Koala\AOP\Pointcut\Parser\AST\ContainerElement' => './Koala/AOP/Pointcut/Parser/AST/ContainerElement.php',
		'Koala\AOP\Pointcut\Parser\AST\Element' => './Koala/AOP/Pointcut/Parser/AST/Element.php',
		'Koala\AOP\Pointcut\Parser\AST\ElementVisitor' => './Koala/AOP/Pointcut/Parser/AST/ElementVisitor.php',
		'Koala\AOP\Pointcut\Parser\AST\ListElement' => './Koala/AOP/Pointcut/Parser/AST/ListElement.php',
		'Koala\AOP\Pointcut\Parser\AST\NotAcceptableElementException' => './Koala/AOP/Pointcut/Parser/AST/NotAcceptableElementException.php',
		'Koala\AOP\Pointcut\Parser\AST\TypeList' => './Koala/AOP/Pointcut/Parser/AST/TypeList.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\AnnotationClassExpression' => './Koala/AOP/Pointcut/Parser/AST/Element/AnnotationClassExpression.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\AnnotationMethodExpression' => './Koala/AOP/Pointcut/Parser/AST/Element/AnnotationMethodExpression.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\AnyArguments' => './Koala/AOP/Pointcut/Parser/AST/Element/AnyArguments.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\Argument' => './Koala/AOP/Pointcut/Parser/AST/Element/Argument.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\ArgumentsExpression' => './Koala/AOP/Pointcut/Parser/AST/Element/ArgumentsExpression.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\ClassAnnotatedPointcut' => './Koala/AOP/Pointcut/Parser/AST/Element/ClassAnnotatedPointcut.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\ClassExpression' => './Koala/AOP/Pointcut/Parser/AST/Element/ClassExpression.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\ExecutionPointcut' => './Koala/AOP/Pointcut/Parser/AST/Element/ExecutionPointcut.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\MethodAnnotatedPointcut' => './Koala/AOP/Pointcut/Parser/AST/Element/MethodAnnotatedPointcut.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\MethodExpression' => './Koala/AOP/Pointcut/Parser/AST/Element/MethodExpression.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\Modifier' => './Koala/AOP/Pointcut/Parser/AST/Element/Modifier.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\NoArguments' => './Koala/AOP/Pointcut/Parser/AST/Element/NoArguments.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\PointcutExpression' => './Koala/AOP/Pointcut/Parser/AST/Element/PointcutExpression.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\PointcutExpressionGroupEnd' => './Koala/AOP/Pointcut/Parser/AST/Element/PointcutExpressionGroupEnd.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\PointcutExpressionGroupStart' => './Koala/AOP/Pointcut/Parser/AST/Element/PointcutExpressionGroupStart.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\PointcutOperator' => './Koala/AOP/Pointcut/Parser/AST/Element/PointcutOperator.php',
		'Koala\AOP\Pointcut\Parser\AST\Element\PointcutType' => './Koala/AOP/Pointcut/Parser/AST/Element/PointcutType.php',
		'Koala\AOP\Proxy\NoProxyReplacer' => './Koala/AOP/Proxy/NoProxyReplacer.php',
		'Koala\AOP\Proxy\ProxyBuilder' => './Koala/AOP/Proxy/ProxyBuilder.php',
		'Koala\AOP\Proxy\ProxyFinder' => './Koala/AOP/Proxy/ProxyFinder.php',
		'Koala\AOP\Proxy\ProxyGenerator' => './Koala/AOP/Proxy/ProxyGenerator.php',
		'Koala\AOP\Proxy\ProxyReplacer' => './Koala/AOP/Proxy/ProxyReplacer.php',
		'Koala\AOP\Proxy\ProxyReplacerFactory' => './Koala/AOP/Proxy/ProxyReplacerFactory.php',
		'Koala\AOP\Proxy\SimpleProxyBuilder' => './Koala/AOP/Proxy/SimpleProxyBuilder.php',
		'Koala\AOP\Proxy\SimpleProxyFinder' => './Koala/AOP/Proxy/SimpleProxyFinder.php',
		'Koala\AOP\Proxy\SimpleProxyGenerator' => './Koala/AOP/Proxy/SimpleProxyGenerator.php',
		'Koala\AOP\Proxy\SimpleProxyReplacer' => './Koala/AOP/Proxy/SimpleProxyReplacer.php',
		'Koala\AOP\Proxy\SimpleProxyReplacerFactory' => './Koala/AOP/Proxy/SimpleProxyReplacerFactory.php',
		'Koala\AOP\Proxy\Compiling\CompiledProxy' => './Koala/AOP/Proxy/Compiling/CompiledProxy.php',
		'Koala\AOP\Proxy\Compiling\ProxyCompiler' => './Koala/AOP/Proxy/Compiling/ProxyCompiler.php',
		'Koala\AutoLoad\AutoLoaderDumper' => './Koala/AutoLoad/AutoLoaderDumper.php',
		'Koala\AutoLoad\PSR0AutoLoader' => './Koala/AutoLoad/PSR0AutoLoader.php',
		'Koala\Cache\FileCache' => './Koala/Cache/FileCache.php',
		'Koala\Cache\ICache' => './Koala/Cache/ICache.php',
		'Koala\Collection\ArrayList' => './Koala/Collection/ArrayList.php',
		'Koala\Collection\IList' => './Koala/Collection/IList.php',
		'Koala\Collection\IMap' => './Koala/Collection/IMap.php',
		'Koala\Collection\Map' => './Koala/Collection/Map.php',
		'Koala\DI\Container' => './Koala/DI/Container.php',
		'Koala\DI\IContainer' => './Koala/DI/IContainer.php',
		'Koala\DI\ParameterNotExistsException' => './Koala/DI/PrameterNotExistsException.php',
		'Koala\DI\ServiceNotExistsException' => './Koala/DI/ServiceNotExistsException.php',
		'Koala\DI\Definition\Argument\ParameterArgument' => './Koala/DI/Definition/Argument/ParameterArgument.php',
		'Koala\DI\Definition\Argument\ServiceDependency' => './Koala/DI/Definition/Argument/ServiceDependency.php',
		'Koala\DI\Definition\Argument\SetupMethod' => './Koala/DI/Definition/Argument/SetupMethod.php',
		'Koala\DI\Definition\Argument\ValueArgument' => './Koala/DI/Definition/Argument/ValueArgument.php',
		'Koala\DI\Definition\Argument\WiringArgument' => './Koala/DI/Definition/Argument/WiringArgument.php',
		'Koala\DI\Definition\Configuration\ArrayConfigurationDefinition' => './Koala/DI/Definition/Configuration/ArrayConfigurationDefinition.php',
		'Koala\DI\Definition\Configuration\ArrayServiceDefinition' => './Koala/DI/Definition/Configuration/ArrayServiceDefinition.php',
		'Koala\DI\Definition\Configuration\ConfigurationDefinition' => './Koala/DI/Definition/Configuration/ConfigurationDefinition.php',
		'Koala\DI\Definition\Configuration\ServiceDefinition' => './Koala/DI/Definition/Configuration/ServiceDefinition.php',
		'Koala\IO\Storage\FileStorage' => './Koala/IO/Storage/FileStorage.php',
		'Koala\IO\Stream\InputStream' => './Koala/IO/Stream/InputStream.php',
		'Koala\IO\Stream\StringInputStream' => './Koala/IO/Stream/StringInputStream.php',
		'Koala\Reflection\MethodMatcher' => './Koala/Reflection/MethodMatcher.php',
		'Koala\Reflection\Annotation\Annotation' => './Koala/Reflection/Annotation/Annotation.php',
		'Koala\Reflection\Annotation\DoctrineWrappedAnnotation' => './Koala/Reflection/Annotation/DoctrineWrappedAnnotation.php',
		'Koala\Reflection\Annotation\ParameterNotDefinedException' => './Koala/Reflection/Annotation/ParameterNotDefinedException.php',
		'Koala\Reflection\Annotation\SimpleAnnotation' => './Koala/Reflection/Annotation/SimpleAnnotation.php',
		'Koala\Reflection\Annotation\Parsing\AnnotationExpression' => './Koala/Reflection/Annotation/Parsing/AnnotationExpression.php',
		'Koala\Reflection\Annotation\Parsing\AnnotationExpressionMatcher' => './Koala/Reflection/Annotation/Parsing/AnnotationExpressionMatcher.php',
		'Koala\Reflection\Annotation\Parsing\AnnotationResolver' => './Koala/Reflection/Annotation/Parsing/AnnotationResolver.php',
		'Koala\Reflection\Annotation\Parsing\DoctrineAnnotationResolver' => './Koala/Reflection/Annotation/Parsing/DoctrineAnnotationResolver.php',
		'Koala\Reflection\Annotation\Parsing\SimpleAnnotationExpressionMatcher' => './Koala/Reflection/Annotation/Parsing/SimpleAnnotationExpressionMatcher.php',

	];
	if (isset($classes[$className])) {
		include_once __DIR__ . '/' . $classes[$className];
	}
});
